local ADDONNAME, GrindstoneData = ...
local VERSION = GetAddOnMetadata(ADDONNAME,"Version")
GrindstoneData.Functions = {}
local Grindstone = GrindstoneData.Functions;
local GS = GrindstoneData.Functions;
local _;
-- Change Log 4.3.2
-- Fixed Fjarnskaggl spelling

--Slash Commands
SLASH_Grindstone1, SLASH_Grindstone2 = '/gs', '/Grindstone';	--/Commands
--[VARS] Variables
local _;
local defaults = {
	version = GetAddOnMetadata(ADDONNAME,"Version"),
	hold = false,
	showState = "bags",
	ItemOffset = 0,
	--  1 = above
	--  0 = center
	-- -1 = below
	Selected = {
		["Source"] = 1,
		["Tier"] = 1,
		["Item"] = 1,
	},
	LOCUS = {					-- Archive the Frame Location
		p			= "CENTER",	-- AnchorPoint
		rp 			= "CENTER",	-- relativePoint
		x 			= 0,		-- xOffset
		y 			= 0			-- yOffset
	},
	MassRecipeKnown = { 
		[755] = { -- Prospecting
			["known"] = false,
			[225904] = false,
			[225902] = false,
			[247761] = false,
			[256611] = false,
			[256613] = false,
			[256622] = false,
			[300619] = false,
			[311948] = false,
			[311949] = false,
			[311950] = false,
			[311951] = false,
			[311952] = false,
			[311953] = false,
		},
		[773] = { -- Milling
			["known"] = false,
			[190382] = false,
			[190381] = false,
			[190383] = false,
			[190385] = false,
			[190384] = false,
			[190386] = false,
			[247861] = false,
			[209658] = false,
			[209659] = false,
			[209661] = false,
			[209660] = false,
			[209662] = false,
			[209664] = false,
			[210116] = false,
			[256219] = false,
			[256217] = false,
			[256223] = false,
			[256221] = false,
			[256218] = false,
			[256220] = false,
			[256308] = false,
			[298927] = false,
			[311413] = false,
			[311416] = false,
			[311417] = false,
			[311414] = false,
			[311415] = false,
			[311418] = false,
		}
	},
}
-- Constants
local lastTime 			= 0;
-- UI storage
local UI_Objects 		= {
[01] = {},
[02] = {},
[03] = {},
};

-- Text Format Constants
local RarityColor = {
	["common"] = 	"|cffffffff",
	["uncommon"] = 	"|cff1eff00",
	["superior"] = 	"|cff0070dd",
	["epic"] = 		"|cffa335ee",
	["legendary"] = "|cffff8000",
}
local White  				= "|cffffffff";
local Red    				= "|cffff0000";
local Green  				= "|cff00ff00";
local Blue   				= "|cff6060ff";
local Cyan   				= "|cff00ffff";
local Magenta				= "|cffff00ff";
local Yellow 				= "|cffffff00";

local gsTag			= Green.."Grindstone: "..Cyan
-- Archives
local uberArchive = GrindstoneData.Archive;
-- config variables
local holdtabs			= false;
local showState 		= "bags";
local itemOffset 		= 0;
local loadFault = false;
local Selected = {
	["Source"] = 1,
	["Tier"] = 1,
	["Item"] = 1,
};
local massRecipeKnown = {};
local itemButtons = {};
---------------------------------------------------------------------------------------
-- TO DO LIST
---------------------------------------------------------------------------------------
-- ?? Option to change Item tab Direction (L/R)??
-- trigger grind button - protected...
-- CLEAN UP
-- ERROR - thrown when the selected item is mailed out/(sold?)


-- Loading Action
function Grindstone_OnLoad(self)
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("UNIT_INVENTORY_CHANGED");
	self:RegisterEvent("BAG_UPDATE");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_LEAVE_COMBAT");	
	self:RegisterEvent("NEW_RECIPE_LEARNED");
	self:RegisterEvent("TRADE_SKILL_LIST_UPDATE");
	--self:RegisterAllEvents();
end
-- Event Handler
function Grindstone_OnEvent(self, event, ...)
	-- Starts the addon
	--print(event);
	if (event == "ADDON_LOADED") then
		local addon = select(1, ...);
		if (addon == "Grindstone") then
			DEFAULT_CHAT_FRAME:AddMessage(Green.."Grindstone "..Red..VERSION..Green..": Loaded.");
			GrindstoneSVPC = GrindstoneSVPC or CopyTable(defaults) -- load our defaults if we have no SV yet (first run)
			if (GrindstoneSVPC.version == nil or GrindstoneSVPC.version ~= VERSION) then Grindstone.UpdateSVPC() end;
			Grindstone.Initialize();
		end
		return;
	elseif (event == "TRADE_SKILL_LIST_UPDATE" and loadFault) then
		Grindstone.CheckKnown()
	elseif (event == "PLAYER_ENTERING_WORLD" or event == "NEW_RECIPE_LEARNED") then
		--if ... then print("LOGIN") end
		Grindstone.CheckKnown()
		Grindstone.Update()
	elseif (event == "UNIT_INVENTORY_CHANGED" or event == "BAG_UPDATE" or event == "PLAYER_LEAVE_COMBAT") then
		Grindstone.Update()
	end
end

-- Encapsulator for Grindstone Text Tag
function GS.Tag(text) return gsTag..text.."|r"; end

-- Initialize UI
function Grindstone.Initialize()
	--print(GS.Tag("Initialize"))
	-- Import saved settings
	local LOCUS = GrindstoneSVPC.LOCUS;
	GrindstoneWidget:SetPoint(LOCUS.p, UIParent, LOCUS.rp, LOCUS.x, LOCUS.y)
	holdtabs = GrindstoneSVPC.hold;
	showState = GrindstoneSVPC.showState;
	massRecipeKnown = GrindstoneSVPC.MassRecipeKnown;
	--if GrindstoneSVPC.ItemOffset == nil then GrindstoneSVPC.ItemOffset = 0 end	
	itemOffset = GrindstoneSVPC.ItemOffset;
	Selected["Source"] = GrindstoneSVPC.Selected["Source"]
	Selected["Tier"] = GrindstoneSVPC.Selected["Tier"]
	Selected["Item"] = GrindstoneSVPC.Selected["Item"]
	
	-- Create Main Button Frame
	local uiforge = CreateFrame("Button", "uiforge", GrindstoneWidgetFrame, "HFlyOutButtonTemplate")
	uiforge:SetPoint("CENTER",uiforge:GetParent(),"CENTER",5,0)
	uiforge:Show()
	uiforge.ArrowBtnU.Frame.id = 1
	uiforge.ArrowBtnD.Frame.id = 2
	uiforge.ArrowBtnR.Frame.id = 3
	
	-- Set up Sources tab
	for i = 1, 3 do
		button = CreateFrame("Button", "Btn"..i, uiforge.ArrowBtnU.Frame, "HeimdallIconButtonTemplate")
		button:SetPoint("BOTTOM", button:GetParent(), "BOTTOM", 0, (7+((i-1)*(24+3))))
		button:SetNormalTexture(uberArchive[i].FileID)--]pathPrefix..uberArchive[i].Texture)
		button:Show()
		button.Text:Hide()
		button.id = i
		table.insert(UI_Objects[01],button)
	end
	uiforge.ArrowBtnU.Frame:SetHeight(6 + ((3) * (24 + 4)))
	--if (_firstRunTest) then uiforge.ArrowBtnU.Frame:Show() end
	--GS.CheckKnown()
	Grindstone.Update()
end
-- Check for known recipes
function Grindstone.CheckKnown()
	--print(GS.Tag("Check Known"))
	local prof1, prof2 = GetProfessions()
	local skillID1, skillID2 = nil, nil;
	if prof1 ~= nil then _,_,_,_,_,_,skillID1 = GetProfessionInfo(prof1); end
	if prof2 ~= nil then _,_,_,_,_,_,skillID2 = GetProfessionInfo(prof2); end
	
	for k,v in pairs(massRecipeKnown) do
		massRecipeKnown[k].known = tonumber(skillID1) == tonumber(k) or tonumber(skillID2) == tonumber(k)
		if massRecipeKnown[k].known then
			C_TradeSkillUI.OpenTradeSkill(k);
			for key,val in pairs(massRecipeKnown[k]) do
				if key ~= "known" then
					if C_TradeSkillUI.IsTradeSkillReady() then
						if C_TradeSkillUI.GetRecipeInfo(key) == nil then 
							--print(GS.Tag("FAULT"..":"..key)) 
							loadFault = true;
							return
						else
							--print(GS.Tag(C_TradeSkillUI.GetRecipeInfo(key).name))
							massRecipeKnown[k][key] = C_TradeSkillUI.GetRecipeInfo(key).learned
							if loadFault then loadFault = false end;
						end
					else 
						--print(GS.Tag("Not ready."))
						loadFault = true
						return
					end
				end
			end
		end
	end
	C_TradeSkillUI.CloseTradeSkill()
end
-- Verify each variable in the SVPC. 
function Grindstone.UpdateSVPC()
	--print(GS.Tag("UpdateSVPC"))
	if GrindstoneSVPC.version ~=  VERSION then  GrindstoneSVPC.version = VERSION end;
	if GrindstoneSVPC.hold == nil then  GrindstoneSVPC.hold = defaults.hold end;
	if GrindstoneSVPC.showState == nil then  GrindstoneSVPC.showState = defaults.showState end;
	if GrindstoneSVPC.Selected == nil then  GrindstoneSVPC.Selected = CopyTable(defaults.Selected) end;
	if GrindstoneSVPC.LOCUS == nil then  GrindstoneSVPC.LOCUS = CopyTable(defaults.LOCUS) end;
	if GrindstoneSVPC.ItemOffset == nil then  GrindstoneSVPC.ItemOffset = defaults.ItemOffset end;
	if GrindstoneSVPC.MassRecipeKnown == nil then  GrindstoneSVPC.MassRecipeKnown = CopyTable(defaults.MassRecipeKnown) end;
end
-- Update frame 
function Grindstone.Update()
	if (UnitAffectingCombat("player")) then return end;
	if  (lastTime + 1 > time() and lastTime ~= 0 )then return end--and not loadFault) then return end;
	--print(GS.Tag("Update"))
	lastTime = time()
	
	--Hide all Children of Tier and Item
	local kids = {uiforge.ArrowBtnD.Frame:GetChildren()}
	for _, child in ipairs(kids) do
		child:Hide()
	end
	kids = {uiforge.ArrowBtnR.Frame:GetChildren()}
	for _, child in ipairs(kids) do
		child:Hide()
	end
	--Clear BagScan Archive Entry
	local count = 0
	if Selected.Source == 3 then
		uberArchive[03] = {
			["Name"] = "Inventory", 
			["FileID"] = 133633, 
			[01] = {["Name"] = "Milling", ["Action"] = "milling", ["SkillID"] = 773, ["FileID"] = 236229,}, 
			[02] = {["Name"] = "Prospecting", ["Action"] = "prospecting", ["SkillID"] = 755, ["FileID"] = 134081,}}
		-- Scan Bags for grindables
		for i = 1, 2 do
			for j = 1, #uberArchive[i] do
				for k = 1, #uberArchive[i][j] do
					if (showState == "grindable" and (GetItemCount(uberArchive[i][j][k].id) >= 5)) 
					or (showState == "mass" and (GetItemCount(uberArchive[i][j][k].id) >= 20)) 
					or (showState == "bags" and (GetItemCount(uberArchive[i][j][k].id) > 0))
					or (showState == "all") then
						count = count + 1
						uberArchive[03][i][count] = uberArchive[i][j][k]
					end
				end
			end
			count = 0
		end
	end
	-- Populate Tier tab
	local adjust = 0
	for i = 1, #uberArchive[Selected.Source] do
		if UI_Objects[02][i] == nil then
			button = CreateFrame("Button", "Btn"..i, uiforge.ArrowBtnD.Frame, "HeimdallIconButtonTemplate")
			button.id = i
			UI_Objects[02][i] = button
		end
		UI_Objects[02][i]:SetPoint("TOP", UI_Objects[02][i]:GetParent(), "TOP", 0, -(6+((i-1-adjust)*(24+4))))
		UI_Objects[02][i]:SetNormalTexture(uberArchive[Selected.Source][i].FileID);	
		if Selected.Source == 3 and (#uberArchive[03][i] == 0) then 
			UI_Objects[02][i]:Hide()
			adjust = adjust + 1
		else
			UI_Objects[02][i]:Show()
		end 
		UI_Objects[02][i].Text:Hide()
	end
	uiforge.ArrowBtnD.Frame:SetHeight(6 + ((#uberArchive[Selected.Source] - adjust) * (24 + 4)))
	if (#uberArchive[Selected.Source] - adjust) == 0 then uiforge.ArrowBtnD.Frame:SetSize(32, 20) end
	-- Populate Item Tab
	count = 0 
	local row = -1
	for i = 1, #uberArchive[Selected.Source][Selected.Tier] do
		if count % 10 == 0 then row = row + 1 end 
		count = count + 1
		if UI_Objects[03][i] == nil then
			button = CreateFrame("Button", "Btn"..i, uiforge.ArrowBtnR.Frame, "HeimdallIconButtonTemplate")
			button:SetPoint("TOPLEFT", button:GetParent(), "TOPLEFT", (4+((i-1-(floor((count-1)/10)*10))*(24+4))), -4-(24+4)*row)
			button.id = i
			UI_Objects[03][i] = button
		end
		UI_Objects[03][i]:SetNormalTexture(uberArchive[Selected.Source][Selected.Tier][i].FileID)
		UI_Objects[03][i].Text:SetText(GetItemCount(uberArchive[Selected.Source][Selected.Tier][i].id))
		UI_Objects[03][i]:Show()		
	end
	-- Adjust Item Tab Size
	if row ~= 0 and count > 10 then count = 10 end 
	local height, width = (4 + (24+4)*(row+1) ),4 + (count * (24 + 4))
	uiforge.ArrowBtnR.Frame:SetSize(width, height)
	-- Adjust Item Tab Alignment(U/C/D)
	--if itemOffset == nil then itemOffset = GrindstoneSVPC.ItemOffset; end
	uiforge.ArrowBtnR.Frame:ClearAllPoints()
	if itemOffset == 1 then 
		uiforge.ArrowBtnR.Frame:SetPoint("BOTTOMLEFT", uiforge.ArrowBtnR, "BOTTOM", 0, -4)
	elseif itemOffset == 0 then
		uiforge.ArrowBtnR.Frame:SetPoint("LEFT", uiforge.ArrowBtnR, "CENTER")
	else --if == -1 then
		uiforge.ArrowBtnR.Frame:SetPoint("TOPLEFT", uiforge.ArrowBtnR, "TOP", 0, 4)
	end
	-- If no objects to show, else set main button content
	if #uberArchive[Selected.Source] == adjust then 
		uiforge.Text:Hide()
		Selected.Tier = 1
		Selected.Item = 1
		uiforge:SetNormalTexture(134400) --"inv_misc_questionmark"
		uiforge.ArrowBtnR.Frame:SetSize(20,32)
	else
		if uberArchive[Selected.Source][Selected.Tier][1] == nil then Selected.Tier = Selected.Tier + 1 end
		if uberArchive[Selected.Source][Selected.Tier][Selected.Item] == nil then 
			Selected.Item = 1 
			GrindstoneSVPC.Selected["Item"] = Selected["Item"]
		end
		local textNoProf = GS.Tag("Required profession not learned.")
		local textNoMass = gsTag.."This item is not mass grindable."
		local textNotLearned = gsTag.."Mass grind not learned for this item."
		local textTooFewItems = gsTag.."Insufficient resources."
		local grindMacro = "/cast "..(uberArchive[Selected.Source].Action or uberArchive[Selected.Tier].Action).."\n/use "..uberArchive[Selected.Source][Selected.Tier][Selected.Item].Name
		local massGrindMacro;
		local profID, massID, learned = nil, nil, false
		
		profID = (((Selected.Source == 3) and uberArchive[Selected.Source][Selected.Tier].SkillID) or uberArchive[Selected.Source].SkillID);
		if uberArchive[Selected.Source][Selected.Tier][Selected.Item].MassID ~= nil then 
			massID = uberArchive[Selected.Source][Selected.Tier][Selected.Item].MassID 
			learned = massRecipeKnown[profID][massID]
		end;
		if not massRecipeKnown[profID].known then
			massGrindMacro = "/run print(\""..textNoProf.."\")"
		elseif massID == nil then
			massGrindMacro = "/run print(\""..textNoMass.."\")"
		elseif not learned then
			massGrindMacro = "/run print(\""..textNotLearned.."\")"
		elseif GetItemCount(uberArchive[Selected.Source][Selected.Tier][Selected.Item].id) < 20 then
			massGrindMacro = "/run print(\""..textTooFewItems.."\")"
		else
			--massGrindMacro = "/run print(\"Successful Mass Grind.\")"
			massGrindMacro = "/run local C=C_TradeSkillUI;C.OpenTradeSkill("..profID..");local _,_,a,b=C.GetRecipeReagentInfo("..massID..",1);C.CraftRecipe("..massID..",math.floor(b/a));"
		
		end
		
		uiforge:SetNormalTexture(uberArchive[Selected.Source][Selected.Tier][Selected.Item].FileID)
		uiforge.Text:Show()
		uiforge.Text:SetText(GetItemCount(uberArchive[Selected.Source][Selected.Tier][Selected.Item].id))
		uiforge:SetAttribute("type1", "macro") --Left Cilck
		uiforge:SetAttribute("macrotext1", grindMacro)
		uiforge:SetAttribute("type2", "macro") --Right Click
		uiforge:SetAttribute("macrotext2", massGrindMacro)
		
		
	end
end
-- Respond to miniButton click
function Grindstone.SelectButton(self)
	if (self == nil)  then
		return;
	end
	local sid, pid = self.id, self:GetParent().id
	if pid ==1 then 
		Selected["Source"] = sid
		Selected["Tier"] = 1
		Selected["Item"] = 1
		uiforge.ArrowBtnD.Frame:Show()
		if not holdtabs then
			uiforge.ArrowBtnU.Frame:Hide()
			uiforge.ArrowBtnR.Frame:Hide()
		end
	elseif pid == 2 then
		Selected["Tier"] = sid
		Selected["Item"] = 1
		uiforge.ArrowBtnR.Frame:Show()
		if not holdtabs then 
			uiforge.ArrowBtnU.Frame:Hide()
			uiforge.ArrowBtnD.Frame:Hide() 
		end
	else
		Selected["Item"] = sid
		if not holdtabs then 
			uiforge.ArrowBtnU.Frame:Hide()
			uiforge.ArrowBtnD.Frame:Hide()
			uiforge.ArrowBtnR.Frame:Hide() 
		end
	end
	GrindstoneSVPC.Selected["Source"] = Selected["Source"]
	GrindstoneSVPC.Selected["Tier"] = Selected["Tier"]
	GrindstoneSVPC.Selected["Item"] = Selected["Item"]
	Grindstone.Update()
end
-- Setup button tooltips
function Grindstone.SetTooltip(self)
	GameTooltip:ClearLines()
	GameTooltip:SetOwner(self)
	-- determine parent flyout tab
	if self:GetParent().id == 1 then -- Source Tab
		GameTooltip:AddLine(uberArchive[self.id].Name)
	elseif self:GetParent().id == 2 then -- Tier Tab
		GameTooltip:AddLine(uberArchive[Selected.Source][self.id].Name)
		if Selected.Source ~= 3 then
			for i = 1,#uberArchive[Selected.Source][self.id] do
				GameTooltip:AddLine("|T"..uberArchive[Selected.Source][self.id][i].FileID..":0|t "..RarityColor[uberArchive[Selected.Source][self.id][i].Rarity]..uberArchive[Selected.Source][self.id][i].Name.."|r")
			end
		end
	elseif self:GetParent().id == 3 then -- Item Tab
		GameTooltip:SetItemByID(uberArchive[Selected.Source][Selected.Tier][self.id].id)
		-- Determine proper loot list
		local lootList = nil
		if Selected.Source == 1 or (Selected.Source == 3 and Selected.Tier == 1) then
			lootList = GrindstoneData.PigmentList;
		elseif Selected.Source == 2 or (Selected.Source == 3 and Selected.Tier == 2) then
			lootList = GrindstoneData.GemsList;
		end
		-- populate tooltip
		if lootList ~= nil then
			for i = 1, #uberArchive[Selected.Source][Selected.Tier][self.id].Drop do
				local dropRate = ""
				if uberArchive[Selected.Source][Selected.Tier][self.id].DropRate[i] ~= nil then dropRate = uberArchive[Selected.Source][Selected.Tier][self.id].DropRate[i] end
				GameTooltip:AddDoubleLine("|T"..lootList[uberArchive[Selected.Source][Selected.Tier][self.id].Drop[i]].FileID..":0|t "..RarityColor[lootList[uberArchive[Selected.Source][Selected.Tier][self.id].Drop[i]].Rarity]..lootList[uberArchive[Selected.Source][Selected.Tier][self.id].Drop[i]].name.."|r",dropRate.."%")
			end
		end
	end
	GameTooltip:Show()
end
-- Multi-parameter command parser
function Grindstone.MultCmdParse(msg)
	--handle empty msg
	if (msg == "") then
		return "";
	end
	local pos, size, main;
	local sub, find, len = string.sub, string.find, string.len;
	pos = find(msg, " ");
	if (pos == nil) then
		return msg; --handle single param commands
	end
	main = sub(msg, 0, pos - 1);
	size = len(msg);
	msg = sub(msg, pos + 1, size);
	local i = 0;
	local param = {};
	while ((msg ~= "") and (msg ~= " ") and (i < 30)) do
		pos = find(msg, " ");
		if (pos == nil) then
			param[i] = msg;
			break;
		else
			param[i] = sub(msg, 0, pos - 1);
			msg = sub(msg, pos + 1, size);
		end
		i = i + 1;
	end;
	return main, param;
end
-- /Command Controller
function SlashCmdList.Grindstone(msg)
	local param = {};
	msg, param = Grindstone.MultCmdParse(msg);
	local later = Green.."Grindstone:"..Red.." This Command Will Be Active Later";
	
	if msg == nil or msg == ""  or msg == "help" then
		-- Show help text
		print(Green.."Grindstone:"..Cyan.." Help")
		print(Green.."/gs help "..Cyan.."- Show this help text.")
		print(Green.."/gs hide "..Cyan.."- Hide the frame.")
		print(Green.."/gs show "..Cyan.."- Show the frame.")
		print(Green.."/gs hold "..Cyan.."- Toggle tab hold. On: Tabs do not close after selection.")
		print(Green.."/gs state "..Cyan.."- Toggle Bag Filter state.")
		print(Cyan.."  - All - Show all herbs/ores.")
		print(Cyan.."  - Bags - Show herbs/ores in inventory.")
		print(Cyan.."  - Grindable - Show only herbs/ores that can be milled/prospected.")
		print(Cyan.."  - Mass - Show only herbs/ores that can be mass milled/prospected.")
		print(Green.."/gs open "..Cyan.."- Sets the anchor point of the Items tab. Only works if more than 10 Items in tab.	")
		print(Cyan.."  - Center - Anchors Items tab to center.")
		print(Cyan.."  - Up/Bottom - Anchors Items tab to bottom/Opens upward.")
		print(Cyan.."  - Down/Top - Anchors Items tab to top/Opens downward.")		
		print(Green.."/gs settings or /gs cfg "..Cyan.."- Show current variable settings such as Hold and Show State.")
		print(Green.."/gs update or /gs refresh "..Cyan.."- Force the frame to update.")
		print(Green.."/gs clear "..Cyan.."- Clear stored variables. "..Red.."|n **If you are having an error about 'Selected' being nil, run this to reset your saved variables.")
	elseif msg == "hold" then
		-- Toggle tab hold-open
		if holdtabs then
			print(gsTag.."No longer holding tabs open.")
		else
			print(gsTag.."Holding tabs open.")
		end
		holdtabs = not holdtabs
		GrindstoneSVPC.hold = holdtabs
	elseif msg == "state" then
		-- Change inventory filter view state
		local p = nil;
		if param ~= nil and param[0] ~= nil then p = param[0] end
		if p == "bags" or (showState == "all" and p == nil) then
			showState = "bags"
			print(gsTag.."Showing all herbs/ores in bags")
		elseif p == "grindable" or p == "grind" or (showState == "bags" and p == nil) then
			showState = "grindable"
			print(gsTag.."Showing only grindable herbs/ores in bags")
		elseif p == "all" or (showState == "grindable" and p == nil) then
			showState = "all"
			print(gsTag.."Showing all herbs/ores")
		elseif p == "mass" or (showState == "all" and p == nil) then
			showState = "mass"
			print(gsTag.."Showing mass grindable herbs/ores in bags")
		else 
			print(gsTag.."State "..Red..p..Cyan.." not recognized.")
		end
		GrindstoneSVPC.showState = showState
		Grindstone.Update()
	elseif msg == "show" then
		-- Show frame
		GrindstoneWidget:Show()
	elseif msg == "hide" then
		-- Hide frame
		GrindstoneWidget:Hide()
	elseif msg == "cfg" or msg == "settings" then
		-- Print variable values
		local anchor = {[1] = "Up", [0] = "Center", [-1] = "Down"}
		print(gsTag.."Settings:\nState: "..showState.."\nHold: "..tostring(holdtabs).."\nAnchor: "..anchor[itemOffset].."\nSelection: "..Selected["Source"]..","..Selected["Tier"]..","..Selected["Item"])
	elseif msg == "update" or msg == "refresh" then
		-- Force frame update
		Grindstone.Update()
	elseif msg == "clear" then
		-- Reset Saved Variables to defaults
		GrindstoneSVPC = CopyTable(defaults);
		print(gsTag.."Variables cleared.")
	elseif msg == "open" then
		-- Change the opening direction of the Items Tab
		local p = nil;
		if param ~= nil and param[0] ~= nil then p = param[0] end
		if p == "center" or p == nil then
			itemOffset = 0
			print(gsTag.."Opening Item tab straight out.")
		elseif p == "up" or p == "bottom" then
			itemOffset = 1
			print(gsTag.."Opening Item tab upward.")
		elseif p == "down" or p == "top" then
			itemOffset = -1
			print(gsTag.."Opening Item tab downward.")
		else 
			print(gsTag.."Opening alignment tag not recognized.")
		end
		GrindstoneSVPC.ItemOffset = itemOffset;
		Grindstone.Update()
	elseif msg == "process" then
		-- trigger the active grind button
		--RunMacroText(macroText);
		--uiforge:Click("LeftButton")
	elseif msg == "test" then
		--GS.CheckKnown()
		print(GS.Tag("Nothing to see here. Move along."))
		for k,v in pairs(massRecipeKnown) do
			print(k..":"..tostring(v))
			if massRecipeKnown[k].known then
			for key,val in pairs(massRecipeKnown[k]) do
				print(((key ~="known" and C_TradeSkillUI.GetRecipeInfo(key).name) or key)..":"..tostring(val))
			end
			end
		end
--		for k,v in pairs(massProspectKnown) do
--			print(k..":"..tostring(v))
--		end
--		print(#massMillKnown)
--		for k,v in pairs(massMillKnown) do
--			print(k..":"..tostring(v))
--		end
		
		
	end
end
--Add functions to global
_G[ADDONNAME] = Grindstone;